10 CLEAR , &HFBFF: DEF SEG
20 REM                           PC-ECG.BAS 
30 REM       Software for the PC driven Electrocardiogram v1.1: G Cattley.
40 DEFINT A-Z:DIM Z(2)
50 PORT = &H378: DELAY = 15:XPOS = 110:S = &HFC00
60 FOR I = 0 TO 78 : READ D : POKE S+I,D : NEXT
70 DATA   &H55,&H89,&HE5,&H8B,&H76,&H08,&H8B,&H14,&H8B,&H76,&H06,&H8B,&H2C,&HBB
80 DATA   &H4F,&HFC,&HB9,&H00,&H00,&H42,&HED,&H4A,&H25,&H80,&H00,&H74,&H06,&H41
90 DATA   &HE8,&H1D,&H00,&HEB,&HF2,&H89,&H0F,&H42,&HED,&H4A,&H25,&H80,&H00,&H75
100 DATA  &H06,&H41,&HE8,&H0D,&H00,&HEB,&HF2,&H43,&H81,&HFB,&HCE,&HfE,&H75,&HD8
110 DATA  &H5D,&HCA,&H04,&H00,&HB0,&HFF,&HEE,&HE8,&H07,&H00,&HB0,&HFE,&HEE,&HE8
120 DATA  &H01,&H00,&HC3,&H89,&HE8,&H48,&H75,&HFD,&HC3
130 SCREEN 2:CLS:BOX=0
140 PRINT:PRINT"                         PC driven Electrocardiogram"
150 PRINT:PRINT"                       Electronics Australia July 1995 "
160 PRINT:PRINT"                                                       "
170 PRINT:PRINT"                                ECG Main Menu"
180 PRINT:PRINT"
190 PRINT:PRINT"                      1:  Read and store waveform"
200 PRINT:PRINT"                      2:  Continuous monitoring"
210 PRINT:PRINT"                      3:  Save current waveform to disk"
220 PRINT:PRINT"                      4:  Load waveform from disk"
230 PRINT:PRINT"                      5:  Display waveform"
240 PRINT:PRINT"                      6:  Modify parameters"
250 A$=INKEY$:IF A$<"1" OR  A$>"6" THEN 250
260 ON VAL (A$) GOSUB 280,340,920,1060,400,530
270 GOTO 130
280 CLS
290 LOCATE 1,1:PRINT"                                 Sampling...                                  ";:GOSUB 690
300 LOCATE 24,1:PRINT" Press space to sample again, or ESC to store waveform and return to main menu";
310 A$=INKEY$:IF A$<>CHR$(27) AND A$<>" " THEN 310
320 IF A$=" " THEN 290
330 RETURN
340 CLS
350 LOCATE 24,1:PRINT"    Continuous sampling. Press ESC to store waveform and return to main menu";
360 IF INKEY$=CHR$(27) THEN RETURN
370 LOCATE 1,1:PRINT"                                 Sampling...                                  "
380 GOSUB 690
390 GOTO 360
400 CLS:PRINT:PRINT:PRINT:PRINT"                           Print waveform to printer"
410 PRINT:PRINT:PRINT" This will send the current waveform to the screen or printer."
420 PRINT:PRINT:PRINT"If printing, ensure that the printer is connected to the printer port!"
430 PRINT:PRINT:PRINT:PRINT:PRINT"Press RETURN to display wave on screen, or ESC to return to main menu"
440 A$=INKEY$:IF A$<>CHR$(27)AND A$<>CHR$(13) THEN 440
450 IF A$=CHR$(27) THEN RETURN
460 CLS:BOX = 1 : GOSUB 710
470 LOCATE 23,1:PRINT"Press P to print this waveform, or ESC to cancel"
480 A$=INKEY$:IF A$<>CHR$(27) AND A$<>"p" AND A$<>"P" THEN 480
490 IF A$=CHR$(27) THEN RETURN
500 LOCATE 23,1:PRINT SPACE$(79)
510 GOSUB 790
520 RETURN
530 CLS: LOCATE 8,8
540 PRINT"1:   Change Zoom level (";DELAY;")"
550 PRINT:PRINT"       2:   Change Printer port address (&H";HEX$(PORT);")"
560 PRINT:PRINT:PRINT"                        Press ESC to return to main menu":PRINT:PRINT
570 A$=INKEY$:IF A$<>CHR$(27) AND A$<>"1"AND A$<>"2" THEN 570
580 IF A$="1" THEN INPUT" New Zoom value (1 to 50 recommended)";DELAY
590 IF DELAY <1 OR DELAY >255 THEN PRINT:PRINT" Sorry, but that Zoom value was out of range. Try again...":PRINT:PRINT:GOTO 580
600 CLS: LOCATE 8,1:B$="1"
610 IF A$="2" THEN PRINT"   1:    Printer port address at &H378"
620 IF A$="2" THEN PRINT"   2:    Printer port address at &H278"
630 IF A$="2" THEN PRINT"   3:    Printer port address at &H3BC"
640 IF A$="2" THEN PRINT:PRINT:PRINT:INPUT"Select 1,2 or 3";B$
650 IF B$="1" THEN PORT=&H378:RETURN
660 IF B$="2" THEN PORT=&H278:RETURN
670 IF B$="3" THEN PORT=&H3BC:RETURN
680 GOTO 600
690 DS$ = " "
700 DEF SEG : CALL S(PORT,DELAY)
710 IF BOX = 1 THEN GOSUB 1190
720 LINE (8,8)-(624,167),0,BF:PRESET(8,PEEK(&HFC50)-110)
730 FOR I = 8 TO 624
740 Y= PEEK(&HFC50+I)-XPOS
750 IF Y>8 THEN LINE -(I,Y)
760 NEXT
770 LOCATE 21,40-(LEN(DS$)/2):PRINT DS$
780 RETURN
790 WIDTH "LPT1:",255
800 LPRINT CHR$(27)+CHR$(65)+CHR$(8);
810 FOR J=1 TO 9:LPRINT:NEXT
820 FOR C = 0 TO 79
830 LPRINT SPACE$(9);
840 LPRINT CHR$(27)+CHR$(75)+CHR$(144)+CHR$(1);
850 FOR R= 199 TO 0 STEP -1
860 GET(8*C+7,R)-(8*C,R),Z
870 LPRINT CHR$(Z(2))+CHR$(Z(2));
880 NEXT:LPRINT:NEXT
890 FOR J=1 TO 10 :LPRINT:NEXT
900 LPRINT CHR$(27)+CHR$(65)+CHR$(12);
910 RETURN
920 CLS: PRINT"Save waveform"
930 GOSUB 710
940 LOCATE 23,1:PRINT"Press RETURN to save this waveform, or ESC to cancel.";
950 A$=INKEY$:IF A$<>CHR$(27) AND A$<>CHR$(13) THEN 950
960 IF A$=CHR$(27) THEN RETURN
970 LOCATE 23,1:PRINT"                                                     "
980 LOCATE 23,1:INPUT"Filename to save as (No extension please)";F$
990 F$=F$+".ECG"
1000 INPUT"description to store with wave";DS$
1010 OPEN F$ FOR OUTPUT AS #2:WRITE#2,DS$:FOR I = 0 TO 640 : WRITE#2,PEEK(&HFC4F+I):NEXT
1020 CLOSE#2
1030 LOCATE 23,1:PRINT"Waveform saved. Press RETURN to continue.            ";
1040 A$=INKEY$:IF A$<>CHR$(13) THEN 1040
1050 RETURN
1060 CLS: PRINT"Load waveform"
1070 LOCATE 23,1:PRINT"Press RETURN to load a waveform, or ESC to cancel.";
1080 A$=INKEY$:IF A$<>CHR$(27) AND A$<>CHR$(13) THEN 1080
1090 IF A$=CHR$(27) THEN RETURN
1100 LOCATE 23,1:PRINT"                                                     "
1110 LOCATE 23,1:INPUT"Filename to load (No extension please)";F$
1120 F$=F$+".ECG":OPEN F$ FOR INPUT AS #2
1130 INPUT#2,DS$:FOR I= 1 TO 640:INPUT#2,A$:POKE &HFC4F+I,VAL(A$):NEXT
1140 CLOSE#2
1150 GOSUB 710
1160 LOCATE 23,1:PRINT"Waveform loaded. Press RETURN to continue.            ";
1170 A$=INKEY$:IF A$<>CHR$(13) THEN 1040
1180 RETURN
1190 LOCATE 1,1:PRINT"";:FOR I = 1  TO 77:PRINT"";:NEXT:PRINT""
1200 FOR J = 1 TO 20:PRINT"";:FOR I = 1  TO 77:PRINT" ";:NEXT:PRINT"":NEXT
1210 PRINT"";:FOR I = 1  TO 77:PRINT"";:NEXT:PRINT""
1220 RETURN
